Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package quasiquotes
  Definition Classes
    reflect
- Holes
- Parsers
- Placeholders
- Quasiquotes
- Rank
- Reifiers

t

scala.reflect.quasiquotes

# Holes 

###

#### trait Holes extends AnyRef

Defines abstractions that provide support for splicing into Scala syntax.

Self Type
  Quasiquotes
Source
  Holes.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Quasiquotes
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Holes
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  class ApplyHole extends Quasiquotes.Hole
2.  abstract class Hole extends AnyRef

   Hole encapsulates information about unquotees in quasiquotes.

   Hole encapsulates information about unquotees in quasiquotes. It packs together a rank, pre-reified tree representation (possibly preprocessed) and position.

3.  class UnapplyHole extends Quasiquotes.Hole

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Holes to any2stringadd[Holes] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Holes, B)
   Implicit
     This member is added by an implicit conversion from Holes to ArrowAssoc[Holes] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def ensuring(cond: (Holes) ⇒ Boolean, msg: ⇒ Any): Holes
   Implicit
     This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (Holes) ⇒ Boolean): Holes
   Implicit
     This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: ⇒ Any): Holes
    Implicit
      This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): Holes
    Implicit
      This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Holes to StringFormat[Holes] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  final def notify(): Unit
    Definition Classes
      AnyRef
21.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
22.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
23.  def toString(): String
    Definition Classes
      AnyRef → Any
24.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
25.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
26.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
27.  def →[B](y: B): (Holes, B)
    Implicit
      This member is added by an implicit conversion from Holes to ArrowAssoc[Holes] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
28.  object Hole
29.  object unlifters

    Full support for unliftable implies that it's possible to interleave deconstruction with higher rank and unlifting of the values.

    Full support for unliftable implies that it's possible to interleave deconstruction with higher rank and unlifting of the values. In particular extraction of List[Tree] as List[T: Unliftable] requires helper extractors that would do the job: UnliftListElementwise[T]. Similarly List[List[Tree]] needs UnliftListOfListsElementwise[T].

    See also "unlift list" tests in UnapplyProps.scala

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Holes to any2stringadd[Holes]

### Inherited by implicit conversion StringFormat from Holes to StringFormat[Holes]

### Inherited by implicit conversion Ensuring from Holes to Ensuring[Holes]

### Inherited by implicit conversion ArrowAssoc from Holes to ArrowAssoc[Holes]

### Ungrouped